/*============================================================================
//	apci34w.cs
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//==========================================================================*/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;

namespace SampleP34
{
	/// <summary>
	/// Apci34w ̊Tv̐łB
	/// </summary>
	public class Apci34w
	{
		private int mErrWradll					= SUCCESS;	// bp[֐G[

		//	װޒ萔
		public const int SUCCESS				= 0;	// Successfully proccessed
		public const int ERR_SYSTEM				= 1;	// Call GetLastError()
		public const int ERR_NO_DEVICE			= 2;	// No card
		public const int ERR_IN_USE				= 3;	// Device is in use
		public const int ERR_INVALID_SLOT		= 4;	// Invalid slot number
		public const int ERR_RESOURCE			= 5;	// Resource exhaustion
		public const int ERR_INVALID_PORT		= 6;	// Invalid port
		public const int ERR_INVALID_ARGUMENT	= 7;	// Invalid argument
		public const int ERR_NO_CREATE			= 8;	// No created device
		public const int ERR_WRAPDLL			= -1;	// bp[֐G[

		//	߰Ĕԍ萔
		public const int PORT_1					= 0;
		public const int PORT_2					= 1;
		public const int PORT_3					= 2;
		public const int PORT_4					= 3;

		//	IN01/IN02/IN09/IN10̊荞ݒ萔
		public const int IRQ_ACTIVE_LOW			= 0;	// Active Low
		public const int IRQ_ACTIVE_HIGH		= 1;	// Active High
		public const int IRQ_DISABLE			= 2;	// 荞݋֎~

		// bZ[W
		// Apci34Create  uWMBase ɐݒ肵lɂāAWM_IN01 Ȃǂ
		// ItZbglbZ[Wo܂B
		public const int WM_IN01				= 0;	// IRQ0(IN01)
		public const int WM_IN02				= 1;	// IRQ1(IN02)
		public const int WM_IN09				= 2;	// IRQ2(IN09)
		public const int WM_IN10				= 3;	// IRQ3(IN10)
		public const int WM_TMR					= 4;	// Timer

		//	̑萔
		public const int MAX_SLOTS				= 16;	// Maximum number of slots
		public const int MAX_PORTS				= 4;	// Maximum number of user ports
		public const short SLOT_AUTO			= -1;	// default search

		/*==================================*/
		/*	Resource infomation structure	*/
		/*==================================*/
		public const int MAX_MEM				= 9;	/* number of memory windows */
		public const int MAX_IO					= 20;	/* number of i/o windows */
		public const int MAX_IRQ				= 7;	/* number of irqs */
		public const int MAX_DMA				= 7;	/* number of dmas */
		public const int MAX_RSV				= 3;

		[StructLayout(LayoutKind.Sequential)]
		public struct Resource
		{
			public int		dwNumMemWindows;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemBase;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemLength;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemAttrib;
			public int		dwNumIOPorts;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IO)]
			public int[]	dwIOPortBase;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IO)]
			public int[]	dwIOPortLength;
			public int		dwNumIRQs;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IRQ)]
			public int[]	dwIRQRegisters;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IRQ)]
			public int[]	dwIRQAttrib;
			public int		dwNumDMAs;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_DMA)]
			public int[]	dwDMALst;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_DMA)]
			public int[]	dwDMAAttrib;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_RSV)]
			public int[]	dwReserved1;
		}

		//	荞݃f[^\
		[StructLayout(LayoutKind.Sequential)]
		public struct Mode
		{
			public int		dwIn01;		// IN01̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
			public int		dwIn02;		// IN02̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
			public int		dwIn09;		// IN09̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
			public int		dwIn10;		// IN10̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
		}

		// API
		[DllImport("apci34.dll")]
		public extern static unsafe bool Apci34GetVersion(int* pdwDllVersion, int* pdwDriverVersion); 
		[DllImport("apci34.dll")]
		public extern static unsafe bool Apci34Create(short* pwLogSlot, int hWnd, short uWMBase, int* pvInitArg);
		[DllImport("apci34.dll")]
		public extern static        bool Apci34Close(short wLogSlot);
		[DllImport("apci34.dll")]
		public extern static        bool Apci34GetResource(short wLogSlot, ref Resource pResInfo);
		[DllImport("apci34.dll")]
		public extern static unsafe bool Apci34GetSwitchValue(short wLogSlot, int* pdwSwitchValue);
		[DllImport("apci34.dll")]
		public extern static unsafe bool Apci34InPort(short wLogSlot, int dwLogPort, byte* pbInValue );
		[DllImport("apci34.dll")]
		public extern static        bool Apci34OutPort(short wLogSlot, int dwLogPort, byte bOutValue );
		[DllImport("apci34.dll")]
		public extern static        bool Apci34IrqMode(short wLogSlot, ref Mode pcmode );
		[DllImport("apci34.dll")]
		public extern static        bool Apci34EnableTimer(short wLogSlot, int dwTimerCount, int dwPlescaler );
		[DllImport("apci34.dll")]
		public extern static        bool Apci34DisableTimer(short wLogSlot );
		[DllImport("apci34.dll")]
		public extern static        int  Apci34GetLastError(short wLogSlot);

		/*============================================================================
		// 	  aPCI-P34 DLL,޲ײްްޮݔԍ擾
		// 	  pdwDllVersion		DLLްޮݔԍi[̈ւ߲
		//		  pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
		// ߂l  TRUE
		//		  s FALSE
		//==========================================================================*/
		public unsafe bool GetVersion(int* pdwDllVersion, int* pdwDriverVersion) 
		{
			try
			{
				return Apci34GetVersion(pdwDllVersion, pdwDriverVersion); 
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-P34 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}

		/*============================================================================
		// 	  aPCI-P34̔Cӂ޲̎gp錾
		// 	  pwLogSlot	 gp޲̘_ۯĔԍi[߲
		//		  hWnd		 үނ𑗂鳨޳
		//		  uWMBase	 ƂȂүID
		//		  pvInitArg	 gp(NULL)
		// ߂l  TRUE
		//		  s FALSE
		//==========================================================================*/
		public unsafe bool Create(short* pwLogSlot, int hWnd, short uWMBase, int* pvInitArg)
		{
			try
			{
				return Apci34Create(pwLogSlot, hWnd, uWMBase, pvInitArg);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-P34 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		
		/*============================================================================
		// 	  aPCI-P34̔Cӂ޲̎gpJ
		// 	  wLogSlot ޲̘_ۯĔԍ
		// ߂l  TRUE
		//		  s FALSE
		//==========================================================================*/
		public bool Close(short wLogSlot)
		{
			try
			{
				return Apci34Close(wLogSlot);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-P34 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		
		/*============================================================================
		// 	  w޲ؿ擾
		// 	  wLogSlot	ؿ擾޲̘_ۯĔԍ
		//		  pResInfo	ؿi[\߲̂
		// ߂l  TRUE
		//		  s FALSE
		//==========================================================================*/
		public bool GetResource(short wLogSlot, ref Resource pResInfo)
		{
			try
			{
				return Apci34GetResource(wLogSlot, ref pResInfo);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-P34 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		
		/*============================================================================
		// 	  ۰ذ̒l擾
		//    wLogSlot			۰ذ̒l擾޲̘_ۯĔԍ
		// 		  pdwSwitchValue	۰ذ̒li[̈ւ߲
		// ߂l  TRUE
		//		  s FALSE
		//==========================================================================*/
		public unsafe bool GetSwitchValue(short wLogSlot, int* pdwSwitchValue)
		{
			try
			{
				return Apci34GetSwitchValue(wLogSlot, pdwSwitchValue);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-P34 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		
		/*============================================================================
		// 	  Cӂ߰Ăް
		// 	  wLogSlot	͂޲̘_ۯĔԍ
		//		  dwLogPort	͂_߰
		//		  pbInValue ްi[̈ւ߲
		// ߂l  TRUE
		//		  s FALSE
		//==========================================================================*/
		public unsafe bool InPort(short wLogSlot, int dwLogPort, byte* pbInValue)
		{
			try
			{
				return Apci34InPort(wLogSlot, dwLogPort, pbInValue);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-P34 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		
		/*============================================================================
		// 	  Cӂ߰Ăްo
		// 	  wLogSlot	o͂޲̘_ۯĔԍ
		//		  dwLogPort	o͂_߰
		//		  bOutValue o͂ް
		// ߂l  TRUE
		//		  s FALSE
		//==========================================================================*/
		public bool OutPort(short wLogSlot, int dwLogPort, byte bOutValue)
		{
			try
			{
				return Apci34OutPort(wLogSlot, dwLogPort, bOutValue);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-P34 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		
		/*============================================================================
		// 	  IN01/IN02/IN09/IN10 ̊荞ݐݒ
		//    wLogSlot	o͂޲̘_ۯĔԍ
		//        pcmode    荞ް
		// ߂l  true
		//        s false
		//==========================================================================*/
		public bool IrqMode(short wLogSlot, ref Mode pcmode)
		{
			try
			{
				return Apci34IrqMode(wLogSlot, ref pcmode);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-P34 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		
		//============================================================================
		//    ϰ荞݂Lɂ
		//    wLogSlot	    o͂޲̘_ۯĔԍ
		//        dwTimerCount  ϰ̶
		//        dwPlescaler   ϰ̸ۯg
		// ߂l  true
		//        s false
		//============================================================================
		public bool EnableTimer(short wLogSlot, int dwTimerCount, int dwPlescaler)
		{
			try
			{
				return Apci34EnableTimer(wLogSlot, dwTimerCount, dwPlescaler); 
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-P34 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		
		//============================================================================
		// 	  ϰ荞݂𖳌ɂ
		// 	  wLogSlot	    o͂޲̘_ۯĔԍ
		// ߂l  true
		//        s false
		//============================================================================
		public bool DisableTimer(short wLogSlot)
		{
			try
			{
				return Apci34DisableTimer(wLogSlot);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-P34 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		
		/*============================================================================
		// 	  aPCI-P34̴װ
		// 	  wLogSlot	װ޲̘_ۯĔԍ
		// ߂l װ
		//==========================================================================*/
		public int GetLastError(short wLogSlot)
		{
			try
			{
				if (mErrWradll == ERR_WRAPDLL)	// bp[֐G[Ȃ
				{
					mErrWradll = SUCCESS;		// NA
					return ERR_WRAPDLL;
				} 
				else 
				{
					return Apci34GetLastError(wLogSlot);
				}
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-P34 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return ERR_WRAPDLL;
			}
		}
	
	}
}
