/*============================================================================
//	apci34w.h
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//==========================================================================*/
#pragma once

#include <windows.h>

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Threading;
using namespace System::Runtime::InteropServices;

#ifdef MessageBox
#undef MessageBox
#endif

// NX̐錾
__gc public class Apci34w;

__gc public class Apci34w
{
private:
	static int mErrWradll						= SUCCESS;	// bp[֐G[

public:
	/*==================*/
	/*	Miscellaneous	*/
	/*==================*/
	static const int	MAX_SLOTS				= 16;	/* Maximum number of slots */
	static const int	MAX_PORTS				= 6;	/* Maximum number of user ports */
	static const short 	SLOT_AUTO				= -1;	/* default search */

	/*==================*/
	/*	װޒ萔		*/
	/*==================*/
	static const int	SUCCESS					= 0;	/* Successfully proccessed */
	static const int	ERR_SYSTEM				= 1;	/* Call GetLastError() */
	static const int	ERR_NO_DEVICE			= 2;	/* No card */
	static const int	ERR_IN_USE				= 3;	/* Device is in use */
	static const int	ERR_INVALID_SLOT		= 4;	/* Invalid slot number */
	static const int	ERR_RESOURCE			= 5;	/* Resource exhaustion */
	static const int	ERR_INVALID_PORT		= 6;	/* Invalid port */
	static const int	ERR_INVALID_ARGUMENT	= 7;	/* Invalid argument */
	static const int	ERR_NO_CREATE			= 8;	/* No created device */
	static const int	ERR_WRAPDLL				= -1;	// bp[֐G[

	/*==================*/
	/*	߰Ĕԍ萔		*/
	/*==================*/
	static const int	PORT_1					= 0;
	static const int	PORT_2					= 1;
	static const int	PORT_3					= 2;
	static const int	PORT_4					= 3;

	/*======================================*/
	/*	IN01/IN02/IN09/IN10̊荞ݒ萔	*/
	/*======================================*/
	static const int	IRQ_ACTIVE_LOW			= 0;	// Active Low
	static const int	IRQ_ACTIVE_HIGH			= 1;	// Active High
	static const int	IRQ_DISABLE				= 2;	// 荞݋֎~

	/*============================================================================
	// bZ[W
	// Apci34Create  uWMBase ɐݒ肵lɂāAWM_IN01 Ȃǂ
	// ItZbglbZ[Wo܂B
	//==========================================================================*/
	static const int	WM_IN01					= 0;	// IRQ0(IN01)
	static const int	WM_IN02					= 1;	// IRQ1(IN02)
	static const int	WM_IN09					= 2;	// IRQ2(IN09)
	static const int	WM_IN10					= 3;	// IRQ3(IN10)
	static const int	WM_TMR					= 4;	// Timer

	// \[X
	static const int	MAX_MEM					= 9;
	static const int	MAX_IO					= 20;
	static const int	MAX_IRQ					= 7;
	static const int	MAX_DMA					= 7;
	static const int	MAX_RSV					= 3;

	[StructLayout(LayoutKind::Sequential)]
	__gc class Resource
	{
	public:
		Int32 dwNumMemWindows;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci34w::MAX_MEM)]
		Int32 dwMemBase[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci34w::MAX_MEM)]
		Int32 dwMemLength[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci34w::MAX_MEM)]
		Int32 dwMemAttrib[];
		Int32 dwNumIOPorts;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci34w::MAX_IO)]
		Int32 dwIOPortBase[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci34w::MAX_IO)]
		Int32 dwIOPortLength[];
		Int32 dwNumIRQs;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci34w::MAX_IRQ)]
		Int32 dwIRQRegisters[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci34w::MAX_IRQ)]
		Int32 dwIRQAttrib[];
		Int32 dwNumDMAs;
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci34w::MAX_DMA)]
		Int32 dwDMALst[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci34w::MAX_DMA)]
		Int32 dwDMAAttrib[];
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Apci34w::MAX_RSV)]
		Int32 dwReserved1[];
	};

	//	INxx荞݃f[^
	[StructLayout(LayoutKind::Sequential)]
	__gc class Mode
	{
	public:
		int dwIn01;	// IN01̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
		int dwIn02;	// IN02̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
		int dwIn09;	// IN09̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
		int dwIn10;	// IN10̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
	};

	// API
	[DllImport("apci34.dll")]
	static bool Apci34GetVersion(int* pdwDllVer, int* pdwDrvVer);
	[DllImport("apci34.dll")]
	static bool Apci34Create(short* pwLogSlot, int hWnd, short uWMBase, int* pvInitArg);
	[DllImport("apci34.dll")]
	static bool Apci34Close(short wLogSlot);
	[DllImport("apci34.dll")]
	static bool Apci34GetResource(short wLogSlot, [In][Out] Resource* res);
	[DllImport("apci34.dll")]
	static bool Apci34GetSwitchValue(short wLogSlot, int* dwSwVal);
	[DllImport("apci34.dll")]
	static bool Apci34InPort(short wLogSlot, int dwLogPort, Byte* pbInValue);
	[DllImport("apci34.dll")]
	static bool Apci34OutPort(short wLogSlot, int dwLogPort, Byte bOutValue);
	[DllImport("apci34.dll")]
	static bool Apci34IrqMode(short wLogSlot, [In][Out] Mode* mode);
	[DllImport("apci34.dll")]
	static bool Apci34EnableTimer(short wLogSlot, int dwTimerCount, int dwPlescaler);
	[DllImport("apci34.dll")]
	static bool Apci34DisableTimer(short wLogSlot);
	[DllImport("apci34.dll")]
	static int Apci34GetLastError(short wLogSlot);



	/*============================================================================
	// 	  aPCI-P34 DLL,޲ײްްޮݔԍ擾
	// 	  pdwDllVersion		DLLްޮݔԍi[̈ւ߲
	//		  pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
	// ߂l  true
	//		  s false
	//==========================================================================*/
	static bool GetVersion(int* pdwDllVer, int* pdwDrvVer)
	{
		try {
			return Apci34GetVersion(pdwDllVer, pdwDrvVer);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
	
	/*============================================================================
	// 	  aPCI-P34̔Cӂ޲̎gp錾
	// 	  pwLogSlot	 gp޲̘_ۯĔԍi[߲
	//		  hWnd		 үނ𑗂鳨޳
	//		  uWMBase	 ƂȂүID
	//		  pvInitArg	 gp(NULL)
	// ߂l  true
	//		  s false
	//==========================================================================*/
	static bool Create(short* pwLogSlot, int hWnd, short uWMBase, int* pvInitArg)
	{
		try {
			return Apci34Create(pwLogSlot, hWnd, uWMBase, pvInitArg);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
		
	/*============================================================================
	// 	  aPCI-P34̔Cӂ޲̎gpJ
	// 	  wLogSlot ޲̘_ۯĔԍ
	// ߂l  true
	//		  s false
	//==========================================================================*/
	static bool Close(short wLogSlot)
	{
		try {
			return Apci34Close(wLogSlot);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*============================================================================
	// 	  w޲ؿ擾
	// 	  wLogSlot	ؿ擾޲̘_ۯĔԍ
	//		  pResInfo	ؿi[\߲̂
	// ߂l  true
	//		  s false
	//==========================================================================*/
	static bool GetResource(short wLogSlot, [In][Out] Resource* res)
	{
		try {
			return Apci34GetResource(wLogSlot, res);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
		
	/*============================================================================
	// 	  ۰ذ̒l擾
	//    wLogSlot			۰ذ̒l擾޲̘_ۯĔԍ
	// 		  pdwSwitchValue	۰ذ̒li[̈ւ߲
	// ߂l  true
	//		  s false
	//==========================================================================*/
	static bool GetSwitchValue(short wLogSlot, int* dwSwVal)
	{
		try {
			return Apci34GetSwitchValue(wLogSlot, dwSwVal);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
		
	/*============================================================================
	// 	  Cӂ߰Ăް
	// 	  wLogSlot	͂޲̘_ۯĔԍ
	//		  dwLogPort	͂_߰
	//		  pbInValue ްi[̈ւ߲
	// ߂l  true
	//		  s false
	//==========================================================================*/
	static bool InPort(short wLogSlot, int dwLogPort, Byte* pbInValue)
	{
		try {
			return Apci34InPort(wLogSlot, dwLogPort, pbInValue);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
		
	/*============================================================================
	// 	  Cӂ߰Ăްo
	// 	  wLogSlot	o͂޲̘_ۯĔԍ
	//		  dwLogPort	o͂_߰
	//		  bOutValue o͂ް
	// ߂l  true
	//		  s false
	//==========================================================================*/
	static bool OutPort(short wLogSlot, int dwLogPort, Byte bOutValue)
	{
		try {
			return Apci34OutPort(wLogSlot, dwLogPort, bOutValue);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
		
	/*============================================================================
	// 	  IN01/IN02/IN09/IN10 ̊荞ݐݒ
	//    wLogSlot	o͂޲̘_ۯĔԍ
	//        pcmode    荞ް
	// ߂l  True
	//        s False
	//==========================================================================*/
	static bool IrqMode(short wLogSlot, [In][Out] Mode* mode)
	{
		try {
			return Apci34IrqMode(wLogSlot, mode);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
		
	//============================================================================
	//    ϰ荞݂Lɂ
	//    wLogSlot	    o͂޲̘_ۯĔԍ
	//        dwTimerCount  ϰ̶
	//        dwPlescaler   ϰ̸ۯg
	// ߂l  True
	//        s False
	//============================================================================
	static bool EnableTimer(short wLogSlot, int dwTimerCount, int dwPlescaler)
	{
		try {
			return Apci34EnableTimer(wLogSlot, dwTimerCount, dwPlescaler);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
		
	//============================================================================
	// 	  ϰ荞݂𖳌ɂ
	// 	  wLogSlot	    o͂޲̘_ۯĔԍ
	// ߂l  True
	//        s False
	//============================================================================
	static bool DisableTimer(short wLogSlot)
	{
		try {
			return Apci34DisableTimer(wLogSlot);
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
		
	/*============================================================================
	// 	  aPCI-P34̴װ
	// 	  wLogSlot	װ޲̘_ۯĔԍ
	// ߂l װ
	//==========================================================================*/
	static int GetLastError(short wLogSlot)
	{
		try {
			if (mErrWradll == ERR_WRAPDLL) {	// bp[֐G[Ȃ
				mErrWradll = SUCCESS;			// NA
				return ERR_WRAPDLL;
			} else {
				return Apci34GetLastError(wLogSlot);
			}
		}
		catch (Exception __gc * e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = SUCCESS;	// bp[֐G[
			return ERR_WRAPDLL;
		}
	}
};
