/*============================================================================
//	apci34w.h
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//==========================================================================*/
#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Runtime::InteropServices;

static int mErrWradll;	// bp[֐G[

public class Apci34w
{
public:
	/*==================*/
	/*	Miscellaneous	*/
	/*==================*/
	static const int MAX_SLOTS				= 16;	/* Maximum number of slots */
	static const int MAX_PORTS				= 6;	/* Maximum number of user ports */
	static const short SLOT_AUTO			= -1;	/* default search */

	/*==================*/
	/*	װޒ萔		*/
	/*==================*/
	static const int SUCCESS				= 0;	/* Successfully proccessed */
	static const int ERR_SYSTEM				= 1;	/* Call GetLastError() */
	static const int ERR_NO_DEVICE			= 2;	/* No card */
	static const int ERR_IN_USE				= 3;	/* Device is in use */
	static const int ERR_INVALID_SLOT		= 4;	/* Invalid slot number */
	static const int ERR_RESOURCE			= 5;	/* Resource exhaustion */
	static const int ERR_INVALID_PORT		= 6;	/* Invalid port */
	static const int ERR_INVALID_ARGUMENT	= 7;	/* Invalid argument */
	static const int ERR_NO_CREATE			= 8;	/* No created device */
	static const int ERR_WRAPDLL			= -1;	/* bp[֐G[ */

	/*==================*/
	/*	߰Ĕԍ萔		*/
	/*==================*/
	static const int PORT_1					= 0;
	static const int PORT_2					= 1;
	static const int PORT_3					= 2;
	static const int PORT_4					= 3;

	/*======================================*/
	/*	IN01/IN02/IN09/IN10̊荞ݒ萔	*/
	/*======================================*/
	static const int IRQ_ACTIVE_LOW			= 0;	// Active Low
	static const int IRQ_ACTIVE_HIGH		= 1;	// Active High
	static const int IRQ_DISABLE			= 2;	// 荞݋֎~

	/*============================================================================
	// bZ[W
	// Apci34Create  uWMBase ɐݒ肵lɂāAWM_APCI34_01 Ȃǂ
	// ItZbglbZ[Wo܂B
	//==========================================================================*/
	static const int WM_IN01				= 0;	// IRQ0(IN01)
	static const int WM_IN02				= 1;	// IRQ1(IN02)
	static const int WM_IN09				= 2;	// IRQ2(IN09)
	static const int WM_IN10				= 3;	// IRQ3(IN10)
	static const int WM_TMR					= 4;	// Timer

	static const int MAX_MEM				= 9;	// number of memory windows
	static const int MAX_IO					= 20;	// number of i/o windows
	static const int MAX_IRQ				= 7;	// number of irqs
	static const int MAX_DMA				= 7;	// number of dmas
	static const int MAX_RSV				= 3;

	// \[Xf[^\
	struct Resource {
		int	dwNumMemWindows;
		int dwMemBase[Apci34w::MAX_MEM];
		int dwMemLength[Apci34w::MAX_MEM];
		int dwMemAttrib[Apci34w::MAX_MEM];
		int	dwNumIOPorts;
		int dwIOPortBase[Apci34w::MAX_IO];
		int dwIOPortLength[Apci34w::MAX_IO];
		int dwNumIRQs;
		int dwIRQRegisters[Apci34w::MAX_IRQ];
		int dwIRQAttrib[Apci34w::MAX_IRQ];
		int dwNumDMAs;
		int dwDMALst[Apci34w::MAX_DMA];
		int dwDMAAttrib[Apci34w::MAX_DMA];
		int dwReserved1[Apci34w::MAX_RSV];
	};

	//	荞݃f[^\
	struct Mode {
		int dwIn01;		// IN01̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
		int dwIn02;		// IN02̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
		int dwIn09;		// IN09̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
		int dwIn10;		// IN10̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
	};

	// API
	[DllImport("apci34.dll")]
	static bool Apci34GetVersion( int *pdwDllVer, int *pdwDrvVer );
	[DllImport("apci34.dll")]
	static bool Apci34Create(short* pwLogSlot, int hWnd, short uWMBase, int* pvInitArg);
	[DllImport("apci34.dll")]
	static bool Apci34Close(short wLogSlot);
	[DllImport("apci34.dll")]
	static bool Apci34GetResource(short wLogSlot, Resource *res);
	[DllImport("apci34.dll")]
	static bool Apci34GetSwitchValue(short wLogSlot, int *dwSwVal);
	[DllImport("apci34.dll")]
	static bool Apci34InPort(short wLogSlot, int dwLogPort, Byte* pbInValue);
	[DllImport("apci34.dll")]
	static bool Apci34OutPort(short wLogSlot, int dwLogPort, Byte bOutValue);
	[DllImport("apci34.dll")]
	static bool Apci34IrqMode(short wLogSlot, Mode *md);
	[DllImport("apci34.dll")]
	static bool Apci34EnableTimer(short wLogSlot, int dwTimerCount, int dwPlescaler);
	[DllImport("apci34.dll")]
	static bool Apci34DisableTimer(short wLogSlot);
	[DllImport("apci34.dll")]
	static int Apci34GetLastError(short wLogSlot);

	/*============================================================================
	// 	  aPCI-P34 DLL,޲ײްްޮݔԍ擾
	// 	  pdwDllVersion		DLLްޮݔԍi[̈ւ߲
	//		  pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
	// ߂l  TRUE
	//		  s FALSE
	//==========================================================================*/
	static bool GetVersion(int *pdwDllVer, int* pdwDrvVer)
	{
		mErrWradll = SUCCESS;
		try {
			return Apci34GetVersion(pdwDllVer, pdwDrvVer);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*============================================================================
	// 	  aPCI-P34̔Cӂ޲̎gp錾
	// 	  pwLogSlot	 gp޲̘_ۯĔԍi[߲
	//		  hWnd		 үނ𑗂鳨޳
	//		  uWMBase	 ƂȂүID
	//		  pvInitArg	 gp(NULL)
	// ߂l  TRUE
	//		  s FALSE
	//==========================================================================*/
	static bool Create(short *pwLogSlot, int hWnd, short uWMBase, int *pvInitArg)
	{
		mErrWradll = SUCCESS;
		try {
			return Apci34Create(pwLogSlot, hWnd, uWMBase, pvInitArg);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
		
	/*============================================================================
	// 	  aPCI-P34̔Cӂ޲̎gpJ
	// 	  wLogSlot ޲̘_ۯĔԍ
	// ߂l  TRUE
	//		  s FALSE
	//==========================================================================*/
	static bool Close(short wLogSlot)
	{
		mErrWradll = SUCCESS;
		try {
			return Apci34Close(wLogSlot);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*============================================================================
	// 	  w޲ؿ擾
	// 	  wLogSlot	ؿ擾޲̘_ۯĔԍ
	//		  pResInfo	ؿi[\߲̂
	// ߂l  TRUE
	//		  s FALSE
	//==========================================================================*/
	static bool GetResource(short wLogSlot, Resource *res)
	{
		mErrWradll = SUCCESS;
		try {
			return Apci34GetResource(wLogSlot, res);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}

	/*============================================================================
	// 	  ۰ذ̒l擾
	//    wLogSlot			۰ذ̒l擾޲̘_ۯĔԍ
	// 		  pdwSwitchValue	۰ذ̒li[̈ւ߲
	// ߂l  TRUE
	//		  s FALSE
	//==========================================================================*/
	static bool GetSwitchValue(short wLogSlot, int *dwSwVal)
	{
		mErrWradll = SUCCESS;
		try {
			return Apci34GetSwitchValue(wLogSlot, dwSwVal);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
		
	/*============================================================================
	// 	  Cӂ߰Ăް
	// 	  wLogSlot	͂޲̘_ۯĔԍ
	//		  dwLogPort	͂_߰
	//		  pbInValue ްi[̈ւ߲
	// ߂l  TRUE
	//		  s FALSE
	//==========================================================================*/
	static bool InPort(short wLogSlot, int dwLogPort, Byte *pbInValue)
	{
		mErrWradll = SUCCESS;
		try {
			return Apci34InPort(wLogSlot, dwLogPort, pbInValue);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
		
	/*============================================================================
	// 	  Cӂ߰Ăްo
	// 	  wLogSlot	o͂޲̘_ۯĔԍ
	//		  dwLogPort	o͂_߰
	//		  bOutValue o͂ް
	// ߂l  TRUE
	//		  s FALSE
	//==========================================================================*/
	static bool OutPort(short wLogSlot, int dwLogPort, Byte bOutValue)
	{
		mErrWradll = SUCCESS;
		try {
			return Apci34OutPort(wLogSlot, dwLogPort, bOutValue);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
		
	/*============================================================================
	// 	  IN01/IN02/IN09/IN10 ̊荞ݐݒ
	//    wLogSlot	o͂޲̘_ۯĔԍ
	//        pcmode    荞ް
	// ߂l  True
	//        s False
	//==========================================================================*/
	static bool IrqMode(short wLogSlot, Mode *md)
	{
		mErrWradll = SUCCESS;
		try {
			return Apci34IrqMode(wLogSlot, md);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
		
	//============================================================================
	//    ϰ荞݂Lɂ
	//    wLogSlot	    o͂޲̘_ۯĔԍ
	//        dwTimerCount  ϰ̶
	//        dwPlescaler   ϰ̸ۯg
	// ߂l  True
	//        s False
	//============================================================================
	static bool EnableTimer(short wLogSlot, int dwTimerCount, int dwPlescaler)
	{
		mErrWradll = SUCCESS;
		try {
			return Apci34EnableTimer(wLogSlot, dwTimerCount, dwPlescaler);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
		
	//============================================================================
	// 	  ϰ荞݂𖳌ɂ
	// 	  wLogSlot	    o͂޲̘_ۯĔԍ
	// ߂l  True
	//        s False
	//============================================================================
	static bool DisableTimer(short wLogSlot)
	{
		mErrWradll = SUCCESS;
		try {
			return Apci34DisableTimer(wLogSlot);
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = ERR_WRAPDLL;	// bp[֐G[
			return false;
		}
	}
		
	/*============================================================================
	// 	  aPCI-P34̴װ
	// 	  wLogSlot	װ޲̘_ۯĔԍ
	// ߂l װ
	//==========================================================================*/
	static int GetLastError(short wLogSlot)
	{
		try {
			if (mErrWradll == ERR_WRAPDLL) {	// bp[֐G[Ȃ
				mErrWradll = SUCCESS;			// NA
				return ERR_WRAPDLL;
			} else {
				return Apci34GetLastError(wLogSlot);
			}
		}
		catch (Exception^e) {
			MessageBox::Show(e->Message, "aPCI-P34 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Exclamation);
			mErrWradll = SUCCESS;	// bp[֐G[
			return ERR_WRAPDLL;
		}
	}
};
