/************************************************************************/
/*		aPCI-P34 Device Driver for Windows 2000/XP						*/
/*																		*/
/*			apc34.h	-	Win32 interface definition						*/
/*			date		-	2004/03/11									*/
/************************************************************************/

#ifndef _APCI34_H_
#define	_APCI34_H_

#ifdef	__cplusplus
extern	"C" {
#endif

//	װޒ萔
#define	APCI34_SUCCESS					0	// Successfully proccessed
#define	APCI34_ERR_SYSTEM				1	// Call GetLastError()
#define	APCI34_ERR_NO_DEVICE			2	// No card
#define	APCI34_ERR_IN_USE				3	// Device is in use
#define	APCI34_ERR_INVALID_SLOT			4	// Invalid slot number
#define	APCI34_ERR_RESOURCE				5	// Resource exhaustion
#define	APCI34_ERR_INVALID_PORT			6	// Invalid port
#define	APCI34_ERR_INVALID_ARGUMENT		7	// Invalid argument
#define	APCI34_ERR_NO_CREATE			8	// No created device

//	߰Ĕԍ萔
#define	APCI34_PORT_1					0
#define	APCI34_PORT_2					1
#define	APCI34_PORT_3					2
#define	APCI34_PORT_4					3

//	IN01/IN02/IN09/IN10̊荞ݒ萔
#define APCI34_IRQ_ACTIVE_LOW			0		// Active Low
#define APCI34_IRQ_ACTIVE_HIGH			1		// Active High
#define APCI34_IRQ_DISABLE				2		// 荞݋֎~

// bZ[W
// Apci34Create  uWMBase ɐݒ肵lɂāAWM_APCI34_01 Ȃǂ
// ItZbglbZ[Wo܂B
#ifndef WM_APCI34_IN01
#define WM_APCI34_IN01					0		// IRQ0(IN01)
#define WM_APCI34_IN02					1		// IRQ1(IN02)
#define WM_APCI34_IN09					2		// IRQ2(IN09)
#define WM_APCI34_IN10					3		// IRQ3(IN10)
#define WM_APCI34_TIMER					4		// Timer
#endif

//	̑萔
#define	APCI34_MAX_SLOTS				16		// Maximum number of slots
#define APCI34_MAX_PORTS				4		// Maximum number of user ports
#define	APCI34_SLOT_AUTO		( ( WORD ) ~0U )	// default search

//	Device ID
#define	APCI34_BOARD_ID			0x9134			// pci bus device id
#define	APCI34_VENDOR_ID		0x136c			// pci bus vendor id
												// our device id
#define	APCI34_DEVICE_ID	( ( DWORD )APCI34_BOARD_ID\
							| ( ( DWORD )APCI34_VENDOR_ID << 16 ) )

//	ؿ\
#define	APCI34_MAX_MEM		9			// number of memory windows
#define	APCI34_MAX_IO		20			// number of i/o windows
#define	APCI34_MAX_IRQ		7			// number of irqs
#define	APCI34_MAX_DMA		7			// number of dmas

typedef	struct	_APCI34RESOURCE {
	DWORD	dwNumMemWindows;					/* Not used */
	DWORD	dwMemBase		[APCI34_MAX_MEM];	/* Not used */
	DWORD	dwMemLength		[APCI34_MAX_MEM];	/* Not used */
	DWORD	dwMemAttrib		[APCI34_MAX_MEM];	/* Not used */
	DWORD	dwNumIOPorts;						/* Num IO ports */
	DWORD	dwIOPortBase	[APCI34_MAX_IO];	/* I/O port base */
	DWORD	dwIOPortLength	[APCI34_MAX_IO];	/* I/O port length */
	DWORD	dwNumIRQs;							/* Not used */
	DWORD	dwIRQRegisters	[APCI34_MAX_IRQ];	/* Not used */
	DWORD	dwIRQAttrib		[APCI34_MAX_IRQ];	/* Not used */
	DWORD	dwNumDMAs;							/* Not used */
	DWORD	dwDMALst		[APCI34_MAX_DMA];	/* Not used */
	DWORD	dwDMAAttrib		[APCI34_MAX_DMA];	/* Not used */
	DWORD	dwReserved1		[3];				/* Not used */
} APCI34RESOURCE, *PAPCI34R;

//	荞݃f[^\
typedef struct _APCI34MODE
{
	DWORD	dwIn01;			// IN01̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
	DWORD	dwIn02;			// IN02̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
	DWORD	dwIn09;			// IN09̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
	DWORD	dwIn10;			// IN10̐ݒ (0:Active Low, 1:Active High, 2:荞݋֎~)
} APCI34MODE, *PCAPCI34M;

//	API
BOOL	WINAPI	Apci34GetVersion( PDWORD pdwDllVersion, PDWORD pdwDriverVersion );
BOOL	WINAPI	Apci34Create( PWORD pwLogSlot, HWND hWnd, UINT uWMBase, PVOID pvInitArg );
BOOL	WINAPI	Apci34Close( WORD wLogSlot );
BOOL	WINAPI	Apci34GetResource( WORD wLogSlot, PAPCI34R pres );
BOOL	WINAPI	Apci34GetSwitchValue( WORD wLogSlot, PDWORD pdwSwitchValue );
BOOL	WINAPI	Apci34InPort( WORD wLogSlot, DWORD dwLogPort, PBYTE pbInValue );
BOOL	WINAPI	Apci34OutPort( WORD wLogSlot, DWORD dwLogPort, BYTE bOutValue );
BOOL	WINAPI	Apci34IrqMode( WORD wLogSlot, PCAPCI34M pcmode );
BOOL	WINAPI	Apci34EnableTimer( WORD wLogSlot, DWORD dwTimerCount, DWORD dwPlescaler );
BOOL	WINAPI	Apci34DisableTimer( WORD wLogSlot );
DWORD	WINAPI	Apci34GetLastError( WORD wLogSlot );

#ifdef	__cplusplus
}
#endif

#endif
