/*============================================================================
//	apci31w.c
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 2004/03/11
//
//==========================================================================*/
#define STRICT

#include <windows.h>
#include <tchar.h>
#include "apci34w.h"	/* aPCI-P34 */

/*-------------------------------------
// (STATIC)ϐȂ
//-----------------------------------*/
static BOOL Apci34wGetDllExportFunc();
static HMODULE hDLL = NULL;

/* DLL ߰Ċ֐ڽ̊i[ϐ */
static FARPROC pApci34GetVersion = NULL;
static FARPROC pApci34Create = NULL;
static FARPROC pApci34Close = NULL;
static FARPROC pApci34GetResource = NULL;
static FARPROC pApci34GetSwitchValue = NULL;
static FARPROC pApci34InPort = NULL;
static FARPROC pApci34OutPort = NULL;
static FARPROC pApci34IrqMode = NULL;
static FARPROC pApci34EnableTimer = NULL;
static FARPROC pApci34DisableTimer = NULL;
static FARPROC pApci34GetLastError = NULL;

/*============================================================================
// 	  apci34.dll۰(۰ގʹװƂ)
// 	  
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci34wDllOpen()
{
	if (hDLL != NULL)
		return FALSE;

	hDLL = (HMODULE)LoadLibrary(APCI34_DLL_NAME);
	if (hDLL == NULL)
		return FALSE;

	if (Apci34wGetDllExportFunc() == FALSE)
	{
		Apci34wDllClose();		// DLL֐擾ɎŝDLL۰
		return FALSE;
	}

	return TRUE;
}
/*============================================================================
// 	  apci34.dll
// 	  
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci34wDllClose()
{
	if (hDLL == NULL)
		return TRUE;

	if (FreeLibrary(hDLL) == TRUE)
	{
		hDLL = NULL;
		return TRUE;
	}

	return FALSE;
}
/*============================================================================
// 	  aPCI-P34 DLL,޲ײްްޮݔԍ擾
// 	  pdwDllVersion		DLLްޮݔԍi[̈ւ߲
//		  pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci34wGetVersion(PDWORD pdwDllVersion, PDWORD pdwDriverVersion)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci34GetVersion)(pdwDllVersion, pdwDriverVersion);
}
/*============================================================================
// 	  aPCI-P34̔Cӂ޲̎gp錾
// 	  pwLogSlot	 gp޲̘_ۯĔԍi[߲
//		  hWnd		 үނ𑗂鳨޳
//		  uWMBase	 ƂȂүID
//		  pvInitArg	 gp(NULL)
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci34wCreate(PWORD pwLogSlot, HWND hWnd, UINT uWMBase, PVOID pvInitArg)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci34Create)(pwLogSlot, hWnd, uWMBase, pvInitArg);
}
/*============================================================================
// 	  aPCI-P34̔Cӂ޲̎gpJ
// 	  wLogSlot ޲̘_ۯĔԍ
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci34wClose(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci34Close)(wLogSlot);
}
/*============================================================================
// 	  w޲ؿ擾
// 	  wLogSlot	ؿ擾޲̘_ۯĔԍ
//		  pResInfo	ؿi[\߲̂
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci34wGetResource(WORD wLogSlot, PAPCI34R pResInfo)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci34GetResource)(wLogSlot, pResInfo);
}
/*============================================================================
// 	  ۰ذ̒l擾
//    wLogSlot			۰ذ̒l擾޲̘_ۯĔԍ
// 		  pdwSwitchValue	۰ذ̒li[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci34wGetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci34GetSwitchValue)(wLogSlot, pdwSwitchValue);
}
/*============================================================================
// 	  Cӂ߰Ăް
// 	  wLogSlot	͂޲̘_ۯĔԍ
//		  dwLogPort	͂_߰
//		  pbInValue ްi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci34wInPort(WORD wLogSlot, DWORD dwLogPort, PBYTE pbInValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci34InPort)(wLogSlot, dwLogPort, pbInValue);
}
/*============================================================================
// 	  Cӂ߰Ăްo
// 	  wLogSlot	o͂޲̘_ۯĔԍ
//		  dwLogPort	o͂_߰
//		  bOutValue o͂ް
// ߂l  TRUE
//		  s FALSE
//==========================================================================*/
BOOL Apci34wOutPort(WORD wLogSlot, DWORD dwLogPort, BYTE bOutValue)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci34OutPort)(wLogSlot, dwLogPort, bOutValue);
}
/*============================================================================
// 	  IN01/IN02/IN09/IN10 ̊荞ݐݒ
//    wLogSlot	o͂޲̘_ۯĔԍ
//        pcmode    荞ް
// ߂l  True
//        s False
//==========================================================================*/
BOOL Apci34wIrqMode(WORD wLogSlot, PCAPCI34M pcmode)
{
	if (hDLL == NULL)
		return FALSE;

 	return  (*pApci34IrqMode)(wLogSlot, pcmode);
}
//============================================================================
//    ϰ荞݂Lɂ
//    wLogSlot	    o͂޲̘_ۯĔԍ
//        dwTimerCount  ϰ̶
//        dwPlescaler   ϰ̸ۯg
// ߂l  True
//        s False
//============================================================================
BOOL Apci34wEnableTimer(WORD wLogSlot, DWORD dwTimerCount, DWORD dwPlescaler)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci34EnableTimer)(wLogSlot, dwTimerCount, dwPlescaler);
}
//============================================================================
// 	  ϰ荞݂𖳌ɂ
// 	  wLogSlot	    o͂޲̘_ۯĔԍ
// ߂l  True
//        s False
//============================================================================
BOOL Apci34wDisableTimer(WORD wLogSlot)
{
	if (hDLL == NULL)
		return FALSE;

	return (*pApci34DisableTimer)(wLogSlot);
}
/*============================================================================
// 	  aPCI-P34̴װ
// 	  wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//==========================================================================*/
DWORD Apci34wGetLastError(WORD wLogSlot)
{
	if (NULL == hDLL)
		return APCI34_ERR_WRAPDLL;

	return (*pApci34GetLastError)(wLogSlot);
}
/*----------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  TRUE
//		  s FALSE
//--------------------------------------------------------------------------*/
static BOOL Apci34wGetDllExportFunc()
{
	/* Apci34GetVersion ̱ڽ擾 */
	pApci34GetVersion = GetProcAddress(hDLL, _T("Apci34GetVersion"));
	if (pApci34GetVersion == NULL)
		return FALSE;

	/* Apci34Create ̱ڽ擾 */
	pApci34Create = GetProcAddress(hDLL, _T("Apci34Create"));
	if (pApci34Create == NULL)
		return FALSE;

	/* Apci34Close ̱ڽ擾 */
	pApci34Close = GetProcAddress(hDLL, _T("Apci34Close"));
	if (pApci34Close == NULL)
		return FALSE;

	/* Apci34GetResource ̱ڽ擾 */
	pApci34GetResource = GetProcAddress(hDLL, _T("Apci34GetResource"));
	if (pApci34GetResource == NULL)
		return FALSE;

	/* Apci34GetSwitchValue ̱ڽ擾 */
	pApci34GetSwitchValue = GetProcAddress(hDLL, _T("Apci34GetSwitchValue"));
	if (pApci34GetSwitchValue == NULL)
		return FALSE;

	/* Apci34InPort ̱ڽ擾 */
	pApci34InPort = GetProcAddress(hDLL, _T("Apci34InPort"));
	if (pApci34InPort == NULL)
		return FALSE;

	/* Apci34OutPort ̱ڽ擾 */
	pApci34OutPort = GetProcAddress(hDLL, _T("Apci34OutPort"));
	if (pApci34OutPort == NULL)
		return FALSE;

	/* Apci34IrqMode ̱ڽ擾 */
	pApci34IrqMode = GetProcAddress(hDLL, _T("Apci34IrqMode"));
	if (pApci34IrqMode == NULL)
		return FALSE;

	/* Apci34EnableTimer ̱ڽ擾 */
	pApci34EnableTimer = GetProcAddress(hDLL, _T("Apci34EnableTimer"));
	if (pApci34EnableTimer == NULL)
		return FALSE;

	/* Apci34DisableTimer ̱ڽ擾 */
	pApci34DisableTimer = GetProcAddress(hDLL, _T("Apci34DisableTimer"));
	if (pApci34DisableTimer == NULL)
		return FALSE;

	/* Apci34GetLastError ̱ڽ擾 */
	pApci34GetLastError = GetProcAddress(hDLL, _T("Apci34GetLastError"));
	if (pApci34GetLastError == NULL)
		return FALSE;

	return TRUE;	/* SĂ DLL ߰Ċ֐ڽ擾 */
}
